/*
------------------------------------------------------------
	tinyst.c - Tiny Symbol Table
------------------------------------------------------------
 *  David Olofson, 2001
 */

#include <stdlib.h>
#include <string.h>
#ifdef	__BORLANDC__
#include "tinyst\tinyst.h"
#else
#include "tinyst.h"
#endif

tst_t *tst_init(const char *data)
{
	int pos, i;
	tst_t *tst = malloc(sizeof(tst_t));
	if(!tst)
		return NULL;

	tst->data = data;

	pos = 0;
	tst->symbols = 0;
	while(data[pos])
	{
		int len = strlen(data + pos);
		if(!len)
			break;
		++tst->symbols;
		pos += len + 1;
	}

	tst->index = malloc(sizeof(short) * tst->symbols);
	if(!tst->index)
	{
		free(tst);
		return NULL;
	}

	i = 0;
	pos = 0;
	while(data[pos])
	{
		int len = strlen(data + pos);
		if(!len)
			break;
		tst->index[i++] = pos;
		pos += len + 1;
	}

	return tst;
}

int tst_id(tst_t *tst, const char *name)
{
	int i;
	for(i = 1; i < tst->symbols; ++i)
		if(!strcmp(tst_name(tst, i), name))
			return i;

	return 0;
}


const char *tst_name(tst_t *tst, int id)
{
	if( (id < 1) || (id >= tst->symbols) )
		return tst->data;

	return tst->data + tst->index[id];
}
