/*
------------------------------------------------------------
	tinyst.h - Tiny Symbol Table
------------------------------------------------------------
 *  David Olofson, 2001
 */

/*
 * NOTE:
 *	Symbol id 0 is special; it's what you get if
 *	an unknown word or token is passed to TinyST.
 */

#ifndef	_TINYST_H_
#define	_TINYST_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
	const char	*data;
	short		*index;
	int		symbols;
} tst_t;

tst_t *tst_init(const char *data);
int tst_id(tst_t *tst, const char *name);
const char *tst_name(tst_t *tst, int id);

#ifdef __cplusplus
}
#endif

#endif
